/******************************************************************************
  ļ:       Uart0Util.c
  :         sunxiaofei 
  :         CC2538 Uart0غʵ

******************************************************************************/

/*
    
    ޸hal_uart.c
    ʵUart0ķ͹ܣûʵUart0Ľչ
    ҪUart0IOã37У
	Ҫע155пʼע
	һҪԱ
*/


// ͷļ
#include "hal_uart.h"
#include "hw_uart.h"
#include "hw_ioc.h"
#include "OSAL.h"

// ļʹõľ̬
static halUARTCfg_t uartConfig;     // ʼUartʹõUartṹ

// ļʹõľ̬
static uint8 UART0Open(void);       // Uart0       
static void procTx(void);           // Ҫ͵

// Uart0ʼ
void Uart0Init(void)
{
    // ʹUart0 
    SysCtrlPeripheralEnable(SYS_CTRL_PERIPH_UART0);
    
    // Uart0Ĺܽţʹõ TX->PD0RX->PD1
    IOCPinConfigPeriphOutput(GPIO_D_BASE, GPIO_PIN_0, IOC_MUX_OUT_SEL_UART0_TXD);
    IOCPinConfigPeriphInput(GPIO_D_BASE, GPIO_PIN_1, IOC_UARTRXD_UART0);
    GPIOPinTypeUARTInput(GPIO_D_BASE, GPIO_PIN_1);
    GPIOPinTypeUARTOutput(GPIO_D_BASE, GPIO_PIN_0);
    
    // Uartýṹ帳ֵ
    uartConfig.configured = true;               // ṹǷ
    uartConfig.baudRate = HAL_UART_BR_115200;   // 
    uartConfig.callBackFunc = NULL;             // ջص          
    uartConfig.flowControl = false;             // 
    uartConfig.intEnable = true;                // жʹ
    uartConfig.tx.maxBufSize = 170;             // ͻС
    uartConfig.idleTimeout = 5;                 // ʱʱ
    uartConfig.rx.bufferHead = 0;               // ջͷָλ
    uartConfig.rx.bufferTail = 0;               // ջβָλ
    uartConfig.rx.pBuffer = (uint8 *)NULL;      // ջ
    uartConfig.tx.bufferHead = 0;               // ͻͷָλ
    uartConfig.tx.bufferTail = 0;               // ͻβָλ
    uartConfig.tx.pBuffer = (uint8 *)NULL;      // ͻ

    UART0Open();                                // Uart0
}

// Uart0
void Uart0Send(char *str)
{
  if (!uartConfig.configured)
  {
    return ;
  }

  uint16 idx = uartConfig.tx.bufferHead;    // ͷָ
  uint16 cnt = uartConfig.tx.bufferTail;    // ͳȣʼΪβָ

  if (cnt == idx) // ͷβȣ򻺳ʣڷͻС
  {
    cnt = uartConfig.tx.maxBufSize;
  }
  else if (cnt > idx)   // βָͷָ룬ʣΪͻСȥβָͷָ
  {
    cnt = uartConfig.tx.maxBufSize - cnt + idx;
  }
  else /* (cnt < idx) */    // ͷָβָ룬ʣΪͷָβָ֮
  {
    cnt = idx - cnt;
  }

  /* Accept "all-or-none" on write request. */
  if (cnt < osal_strlen(str))       // ĻʣСַȣ򷵻
  {
    return;
  }

  idx = uartConfig.tx.bufferTail;       // idxֵΪβָ

  for (cnt = 0; cnt < osal_strlen(str); cnt++)  // ѭַƵͻ
  {
    uartConfig.tx.pBuffer[idx++] = str[cnt];

    if (idx >= uartConfig.tx.maxBufSize)
    {
      idx = 0;
    }
  }

  halIntState_t intState;               // ٽ
  HAL_ENTER_CRITICAL_SECTION(intState);
  uartConfig.tx.bufferTail = idx;
  procTx();
  HAL_EXIT_CRITICAL_SECTION(intState);

  /* Return the number of bytes actually put into the buffer. */
  return;  
}

// Uart0
static uint8 UART0Open(void)
{

  // ͻռ
  if ((uartConfig.tx.pBuffer = osal_mem_alloc(uartConfig.tx.maxBufSize)) == NULL)
  {
    return HAL_UART_MEM_FAIL;
  }
  
  // ʹж
  IntEnable(INT_UART0);
  // Uart0ʱӡʡֳżУ飬ֹͣλ
  UARTConfigSetExpClk(UART0_BASE, SysCtrlClockGet(), 115200,
                         (UART_CONFIG_WLEN_8 | UART_CONFIG_PAR_NONE | UART_CONFIG_STOP_ONE));

  /* FIFO level set to 1/8th for both RX and TX which is 2 bytes */
  // FIFOֵ
  UARTFIFOLevelSet(UART0_BASE, UART_FIFO_TX1_8, UART_FIFO_RX1_8);
  UARTFIFOEnable(UART0_BASE);

  /* Clear and enable UART TX, RX, CTS and Recieve Timeout interrupt */
  // ж
  UARTIntClear(UART0_BASE, (UART_INT_RX | UART_INT_TX | UART_INT_CTS | UART_INT_RT ));
  UARTIntEnable(UART0_BASE, (UART_INT_RX | UART_INT_TX | UART_INT_CTS | UART_INT_RT ));
  
  // ʹUart0
  UARTEnable(UART0_BASE);

  return HAL_UART_SUCCESS;
}

// 
static void procTx(void)
{
  // ͷβָ
  uint16 head = uartConfig.tx.bufferHead;
  uint16 tail = uartConfig.tx.bufferTail;
  
  // ͷβȵʱ˵Ҫ
  while (head != tail)  
  {
    // ʹõUARTCharPut
    // MTģʹõUARTCharPutNonBlocking
    // зʹUARTCharPutNonBlockingᷢӡȫ
    // ޸ΪUARTCharPutӡ
    // UARTCharPutUARTCharPutNonBlockingװʵ
    // Բ֪ΪUARTCharPutǷӰ
    // ҪһӦʹUARTCharPutǷᷢӰ
    // ǿҽԺʹã
    UARTCharPut(UART0_BASE, uartConfig.tx.pBuffer[head]);
    if (++head >= uartConfig.tx.maxBufSize)
    {
      head = 0;
    }
  }

  uartConfig.tx.bufferHead = head;
}